import 'package:equatable/equatable.dart';
import 'package:flutter_riverpod/flutter_riverpod.dart';
import '../../models/response_save_pengantaran_hasil_model.dart';
import '../../provider/dio_provider.dart';
import '../../repository/base_repository.dart';
import '../../repository/pengantaran_hasil_dokter_repository.dart';

// 3. state provider
final pengantaranHasilDokterSave = StateNotifierProvider<
        PengantaranhasilDokterSaveNotifier, PengantaranhasilDokterSaveState>(
    (ref) => PengantaranhasilDokterSaveNotifier(ref: ref));

// 2. notifier
class PengantaranhasilDokterSaveNotifier
    extends StateNotifier<PengantaranhasilDokterSaveState> {
  final Ref ref;
  PengantaranhasilDokterSaveNotifier({required this.ref})
      : super(PengantaranhasilDokterSaveStateInit());
  void pengantaranHasilDokterSave({
    required String courierID,
    required String tipeID,
    required String deliveryID,
  }) async {
    try {
      state = PengantaranhasilDokterSaveStateLoading();
      final resp =
          await PengantaranHasilDokterRepository(dio: ref.read(dioProvider))
              .pengantaranHasilDokterSave(
                courierID: courierID,
                tipeID: tipeID,
                deliveryID: deliveryID
              );

      state = PengantaranhasilDokterSaveStateDone(model: resp);
    } catch (e) {
      if (e is BaseRepositoryException) {
        state = PengantaranhasilDokterSaveStateError(message: e.message ?? "");
      } else {
        state = PengantaranhasilDokterSaveStateError(message: e.toString());
      }
    }
  }
}

// 1. state
abstract class PengantaranhasilDokterSaveState extends Equatable {
  final DateTime date;
  const PengantaranhasilDokterSaveState(this.date);
  @override
  List<Object?> get props => [date];
}

class PengantaranhasilDokterSaveStateInit
    extends PengantaranhasilDokterSaveState {
  PengantaranhasilDokterSaveStateInit() : super(DateTime.now());
}

class PengantaranhasilDokterSaveStateLoading
    extends PengantaranhasilDokterSaveState {
  PengantaranhasilDokterSaveStateLoading() : super(DateTime.now());
}

class PengantaranhasilDokterSaveStateError
    extends PengantaranhasilDokterSaveState {
  final String? message;
  PengantaranhasilDokterSaveStateError({
    required this.message,
  }) : super(DateTime.now());
}

class PengantaranhasilDokterSaveStateDone
    extends PengantaranhasilDokterSaveState {
  final ResponseSavePengantaranHasilModel model;
  PengantaranhasilDokterSaveStateDone({
    required this.model,
  }) : super(DateTime.now());
}
